<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_ServiceInfoDate ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_ServiceInfoDate extends AbstractStructArrayBase
{
    /**
     * The InfoDate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_ServiceInfoDate[]
     */
    public $InfoDate;
    /**
     * Constructor method for ArrayOfJP_ServiceInfoDate
     * @uses ArrayOfJP_ServiceInfoDate::setInfoDate()
     * @param \StructType\JP_ServiceInfoDate[] $infoDate
     */
    public function __construct(array $infoDate = array())
    {
        $this
            ->setInfoDate($infoDate);
    }
    /**
     * Get InfoDate value
     * @return \StructType\JP_ServiceInfoDate[]|null
     */
    public function getInfoDate()
    {
        return $this->InfoDate;
    }
    /**
     * This method is responsible for validating the values passed to the setInfoDate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInfoDate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInfoDateForArrayConstraintsFromSetInfoDate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_ServiceInfoDateInfoDateItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_ServiceInfoDateInfoDateItem instanceof \StructType\JP_ServiceInfoDate) {
                $invalidValues[] = is_object($arrayOfJP_ServiceInfoDateInfoDateItem) ? get_class($arrayOfJP_ServiceInfoDateInfoDateItem) : sprintf('%s(%s)', gettype($arrayOfJP_ServiceInfoDateInfoDateItem), var_export($arrayOfJP_ServiceInfoDateInfoDateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InfoDate property can only contain items of type \StructType\JP_ServiceInfoDate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InfoDate value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceInfoDate[] $infoDate
     * @return \ArrayType\ArrayOfJP_ServiceInfoDate
     */
    public function setInfoDate(array $infoDate = array())
    {
        // validation for constraint: array
        if ('' !== ($infoDateArrayErrorMessage = self::validateInfoDateForArrayConstraintsFromSetInfoDate($infoDate))) {
            throw new \InvalidArgumentException($infoDateArrayErrorMessage, __LINE__);
        }
        $this->InfoDate = $infoDate;
        return $this;
    }
    /**
     * Add item to InfoDate value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceInfoDate $item
     * @return \ArrayType\ArrayOfJP_ServiceInfoDate
     */
    public function addToInfoDate(\StructType\JP_ServiceInfoDate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_ServiceInfoDate) {
            throw new \InvalidArgumentException(sprintf('The InfoDate property can only contain items of type \StructType\JP_ServiceInfoDate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InfoDate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_ServiceInfoDate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_ServiceInfoDate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_ServiceInfoDate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_ServiceInfoDate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_ServiceInfoDate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InfoDate
     */
    public function getAttributeName()
    {
        return 'InfoDate';
    }
}
